org.apache.sysds.lops

## Class MMTSJ

- java.lang.Object
- - org.apache.sysds.lops.Lop
  - - org.apache.sysds.lops.MMTSJ

-     public class MMTSJ
      extends Lop

  Lop to perform transpose-identity operation (t(X)%*%X or X%*%t(X)), used to represent CP and MR instruction but in case of MR there is an additional Aggregate at the reducers.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `MMTSJ.MMTSJType`

    - ### Nested classes/interfaces inherited from class org.apache.sysds.lops.Lop

      `Lop.SimpleInstType, Lop.Type, Lop.VisitStatus`

  - ### Field Summary

    - ### Fields inherited from class org.apache.sysds.lops.Lop

      `_beginColumn, _beginLine, _endColumn, _endLine, _filename, CP_CHILD_THREAD, CP_ROOT_THREAD_ID, DATATYPE_PREFIX, FILE_SEPARATOR, FRAME_VAR_NAME_PREFIX, INSTRUCTION_DELIMITOR, LITERAL_PREFIX, MATRIX_VAR_NAME_PREFIX, NAME_VALUE_SEPARATOR, OPERAND_DELIMITOR, PROCESS_PREFIX, SAMPLE_FRACTION, SCALAR_VAR_NAME_PREFIX, UPDATE_INPLACE_PREFIX, VALUETYPE_PREFIX, VARIABLE_NAME_PLACEHOLDER`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MMTSJ(Lop input1, Types.DataType dt, Types.ValueType vt, Types.ExecType et, MMTSJ.MMTSJType type)`
    `MMTSJ(Lop input1, Types.DataType dt, Types.ValueType vt, Types.ExecType et, MMTSJ.MMTSJType type, boolean multiPass)`
    `MMTSJ(Lop input1, Types.DataType dt, Types.ValueType vt, Types.ExecType et, MMTSJ.MMTSJType type, boolean multiPass, int k)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getInstructions(String input_index1, String output_index)` Method should be overridden if needed
    `String` | `toString()` Method to have Lops print their state.

    - ### Methods inherited from class org.apache.sysds.lops.Lop

      `addInput, addOutput, addToDag, createReachable, getAggType, getBeginColumn, getBeginLine, getBroadcastInput, getDataType, getEndColumn, getEndLine, getExecType, getFilename, getID, getInputs, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getInstructions, getLevel, getOutputParameters, getOutputs, getPrivacyConstraint, getProducesIntermediateOutput, getReachable, getSimpleInstructionType, getType, getValueType, getVisited, isAllOutputsCP, isDataExecLocation, isVariable, prepInputOperand, prepInputOperand, prepOperand, prepOperand, prepOutputOperand, prepOutputOperand, prepOutputOperand, prepScalarInputOperand, prepScalarInputOperand, prepScalarLabel, prepScalarOperand, printErrorLocation, removeConsumer, removeOutput, replaceInput, resetVisitStatus, setAllPositions, setBeginColumn, setBeginLine, setConsumerCount, setDataType, setEndColumn, setEndLine, setExecType, setFederatedOutput, setFilename, setPrivacyConstraint, setValueType, setVisited`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### MMTSJ

          public MMTSJ(Lop input1,
                       Types.DataType dt,
                       Types.ValueType vt,
                       Types.ExecType et,
                       MMTSJ.MMTSJType type)

    - #### MMTSJ

          public MMTSJ(Lop input1,
                       Types.DataType dt,
                       Types.ValueType vt,
                       Types.ExecType et,
                       MMTSJ.MMTSJType type,
                       boolean multiPass)

    - #### MMTSJ

          public MMTSJ(Lop input1,
                       Types.DataType dt,
                       Types.ValueType vt,
                       Types.ExecType et,
                       MMTSJ.MMTSJType type,
                       boolean multiPass,
                       int k)

  - ### Method Detail

    - #### toString

          public String toString()

      Description copied from class: `Lop`
      Method to have Lops print their state. This is for debugging purposes.
      Specified by:
        `toString` in class `Lop`

    - #### getInstructions

          public String getInstructions(String input_index1,
                                        String output_index)

      Description copied from class: `Lop`
      Method should be overridden if needed
      Overrides:
        `getInstructions` in class `Lop`
      Parameters:
        `input_index1` - input 1
        `output_index` - output
      Returns:
        instructions as string

Copyright © 2021 The Apache Software Foundation. All rights reserved.